searchNodes=[{"ref":"Operate.html","title":"Operate","type":"module","doc":"Load and run Operate programs (known as &quot;tapes&quot;) encoded in Bitcoin SV transactions. Operate is a toolset to help developers build applications, games and services on top of Bitcoin (SV). It lets you write functions, called &quot;Ops&quot;, and enables transactions to become small but powerful programs, capable of delivering new classes of services layered over Bitcoin. Installation The package is bundled with libsecp256k1 NIF bindings. libtool, automake and autogen are required in order for the package to compile. The package can be installed by adding operate to your list of dependencies in mix.exs. The most recent luerl package published on hex.pm is based on Lua 5.2 which may not be compatible with all Ops. It is recommended to override the luerl dependency with the latest development version to benefit from Lua 5.3. def deps do [ {:operate, &quot;~&gt; 0.1.0-beta.8&quot;}, {:luerl, github: &quot;rvirding/luerl&quot;, branch: &quot;develop&quot;, override: true} ] end Quick start The agent can be used straight away without starting any processes. This will run without caching so should only be used for testing and kicking the tyres. {:ok, tape} = Operate.load_tape(txid) {:ok, tape} = Operate.run_tape(tape) tape.result See load_tape/2 and run_tape/2. Process supervision To enable caching the agent should be started as part of your applications process supervision tree. children = [ {Operate, [ cache: Operate.Cache.ConCache, ]}, {ConCache, [ name: :operate, ttl_check_interval: :timer.minutes(1), global_ttl: :timer.minutes(10), touch_on_read: true ]} ] Supervisor.start_link(children, strategy: :one_for_one) Configuration Operate can be configured with the following options. Additionally, any of these options can be passed to load_tape/2 and run_tape/2 to override the configuration. :tape_adapter - The adapter module used to fetch the tape transaction. :op_adaapter - The adapter module used to fetch the tape&#39;s Ops. :cache - The cache module used for caching tapes and Ops. :extensions - A list of extension modules to extend the VM state. :aliases - A map of references to alias functions to alternative references. :strict - Set false to disable strict mode and ignore missing and/or erring functions. The default configuration: tape_adapter: Operate.Adapter.Bob, op_adapter: Operate.Adapter.OpApi, cache: Operate.Cache.NoCache, extensions: [], aliases: %{}, strict: true"},{"ref":"Operate.html#child_spec/1","title":"Operate.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Operate.html#get_state/1","title":"Operate.get_state/1","type":"function","doc":"Gets Operate&#39;s current VM state and config. If a process has already been started then the existing VM and config is returned. Alternatively a new VM state is initiated and the default config returned. In either case any configuration option can be overridden. Returns a tuple pair containing the VM state and a configuration map."},{"ref":"Operate.html#load_tape/2","title":"Operate.load_tape/2","type":"function","doc":"Loads a tape from the given txid. Fetchs the tape transaction output as well as all of the required functions, and returns a Operate.Tape.t/0 ready for execution in an :ok / :error tuple pair. If an Operate agent process has already been started the existing config will be used. Otherwise a default config will be used. Any configuration option can be overridden. Options Refer to the list of accepted configuration options."},{"ref":"Operate.html#load_tape!/2","title":"Operate.load_tape!/2","type":"function","doc":"As load_tape/2, but returns the tape or raises an exception."},{"ref":"Operate.html#load_tapes_by/2","title":"Operate.load_tapes_by/2","type":"function","doc":"Loads a tape from the given query. The expected format of the query will depend on the Operate.Adapter in use. The transactions as well as all required functions are loaded an a list of Operate.Tape.t/0 are returned in an :ok / :error tuple pair. If an Operate agent process has already been started the existing config will be used. Otherwise a default config will be used. Any configuration option can be overridden. Options Refer to the list of accepted configuration options. Examples For example, if using the default Operate.Adapter.Bob adapter, a Bitquery can be provided. The project attribute cannot be used and unless otherwise specified, limit defaults to 10. Operate.load_tapes_by(%{ &quot;find&quot; =&gt; %{ &quot;out.tape.cell&quot; =&gt; %{ &quot;$elemMatch&quot; =&gt; %{ &quot;i&quot; =&gt; 0, &quot;s&quot; =&gt; &quot;1PuQa7K62MiKCtssSLKy1kh56WWU7MtUR5&quot; } } } })"},{"ref":"Operate.html#load_tapes_by!/2","title":"Operate.load_tapes_by!/2","type":"function","doc":"As load_tapes_by/2, but returns the tapes or raises an exception."},{"ref":"Operate.html#prep_tape/3","title":"Operate.prep_tape/3","type":"function","doc":"Prepare the tape from the given transaction. Optionally specify the output index of the tape."},{"ref":"Operate.html#prep_tape!/3","title":"Operate.prep_tape!/3","type":"function","doc":"As prep_tape/3, but returns the tape or raises an exception."},{"ref":"Operate.html#prep_tapes/3","title":"Operate.prep_tapes/3","type":"function","doc":"Prepare the tapes from the given list of transactions."},{"ref":"Operate.html#run_tape/2","title":"Operate.run_tape/2","type":"function","doc":"Runs the given tape executing each of the tape&#39;s cells and returns the modified and complete Operate.Tape.t/0 in an :ok / :error tuple pair. If an Operate agent process has already been started the existing VM state and config will be used. Otherwise a new state and default config will be used. Any configuration option can be overridden. Options The accepted options are: :extensions - A list of extension modules to extend the VM state. :strict - Strict mode (defaults true). Disable to force the tape to ignore missing and/or erroring cells. :state - Speficy a state which the tape begins execution with (defaults to nil). :vm - Pass an already initiated VM state in which to run the tape."},{"ref":"Operate.html#run_tape!/2","title":"Operate.run_tape!/2","type":"function","doc":"As run_tape/2, but returns the tape or raises an exception."},{"ref":"Operate.html#start_link/1","title":"Operate.start_link/1","type":"function","doc":"Starts an Operate agent process with the given options merged with the default config. Options Refer to the list of accepted configuration options."},{"ref":"Operate.html#version/0","title":"Operate.version/0","type":"function","doc":"Returns the current version number."},{"ref":"Operate.BPU.Cell.html","title":"Operate.BPU.Cell","type":"module","doc":"Bitcoin Processing Unit Cell module. Provides methods for parsing and serializing cells to and from bare maps."},{"ref":"Operate.BPU.Cell.html#from_map/1","title":"Operate.BPU.Cell.from_map/1","type":"function","doc":"Converts the given map or list of maps into a Operate.BPU.Cell.t/0."},{"ref":"Operate.BPU.Cell.html#t:t/0","title":"Operate.BPU.Cell.t/0","type":"type","doc":"BPU Cell"},{"ref":"Operate.BPU.Script.html","title":"Operate.BPU.Script","type":"module","doc":"Bitcoin Processing Unit Script module. Provides methods for parsing and serializing input and output scripts to and from bare maps."},{"ref":"Operate.BPU.Script.html#from_map/1","title":"Operate.BPU.Script.from_map/1","type":"function","doc":"Converts the given map or list of maps into a Operate.BPU.Script.t/0."},{"ref":"Operate.BPU.Script.html#t:t/0","title":"Operate.BPU.Script.t/0","type":"type","doc":"BPU Script"},{"ref":"Operate.BPU.Transaction.html","title":"Operate.BPU.Transaction","type":"module","doc":"Bitcoin Processing Unit Transaction module. Provides methods for parsing and serializing transactions to and from bare maps."},{"ref":"Operate.BPU.Transaction.html#from_map/1","title":"Operate.BPU.Transaction.from_map/1","type":"function","doc":"Converts the given map or list of maps into a Operate.BPU.Transaction.t/0."},{"ref":"Operate.BPU.Transaction.html#t:t/0","title":"Operate.BPU.Transaction.t/0","type":"type","doc":"BPU Transaction"},{"ref":"Operate.Cell.html","title":"Operate.Cell","type":"module","doc":"Module for working with Operate tape cells. A cell represents a single atomic procedure call. A Operate.Cell.t/0 contains the Op script and parameters. When the cell is executed it returns a result. Examples iex&gt; %Operate.Cell{op: &quot;return function(state, a, b) return state + a + b end&quot;, params: [3, 5]} ...&gt; |&gt; Operate.Cell.exec(Operate.VM.init, state: 1) {:ok, 9}"},{"ref":"Operate.Cell.html#exec/3","title":"Operate.Cell.exec/3","type":"function","doc":"Executes the given cell in the given VM state. Options The accepted options are: :state - Specifiy the state which is always the first parameter in the executed function. Defaults to nil. Examples iex&gt; %Operate.Cell{op: &quot;return function(state) return state..&#39; world&#39; end&quot;, params: []} ...&gt; |&gt; Operate.Cell.exec(Operate.VM.init, state: &quot;hello&quot;) {:ok, &quot;hello world&quot;}"},{"ref":"Operate.Cell.html#exec!/3","title":"Operate.Cell.exec!/3","type":"function","doc":"As exec/3, but returns the result or raises an exception. Options The accepted options are: :state - Specifiy the state which is always the first parameter in the executed function. Defaults to nil."},{"ref":"Operate.Cell.html#from_bpu/1","title":"Operate.Cell.from_bpu/1","type":"function","doc":"Converts the given Operate.BPU.Cell.t/0 into a Operate.Cell.t/0. Returns the result in an :ok / :error tuple pair."},{"ref":"Operate.Cell.html#from_bpu!/1","title":"Operate.Cell.from_bpu!/1","type":"function","doc":"As from_bpu/1, but returns the result or raises an exception."},{"ref":"Operate.Cell.html#valid?/1","title":"Operate.Cell.valid?/1","type":"function","doc":"Validates the given cell. Returns true if the cell has a reference and script. Examples iex&gt; %Operate.Cell{ref: &quot;abc&quot;, op: &quot;return 123&quot;} ...&gt; |&gt; Operate.Cell.valid? true iex&gt; %Operate.Cell{} ...&gt; |&gt; Operate.Cell.valid? false"},{"ref":"Operate.Cell.html#t:t/0","title":"Operate.Cell.t/0","type":"type","doc":"Operate Cell"},{"ref":"Operate.Op.html","title":"Operate.Op","type":"module","doc":"Defines an Op struct. Adapters implementing Operate.Adapter.fetch_ops/2 should map the response in to this consistent structure."},{"ref":"Operate.Op.html#t:t/0","title":"Operate.Op.t/0","type":"type","doc":"Operate Op"},{"ref":"Operate.Tape.html","title":"Operate.Tape","type":"module","doc":"Module for working with Operate tapes. An Operate program is a tape made up of one or more cells, where each cell contains a single atomic procedure call (known as an &quot;Op&quot;). When a tape is run, each cell is executed in turn, with the result from each cell is passed to the next cell. This is known as the &quot;state&quot;. Each cell returns a new state, until the final cell in the tape returns the result of the tape. Examples iex&gt; {:ok, tape} = %Operate.Tape{cells: [ ...&gt; %Operate.Cell{op: &quot;return function(state, a) return (state or 0) + a end&quot;, params: [2]}, ...&gt; %Operate.Cell{op: &quot;return function(state, a) return (state or 0) + a end&quot;, params: [3]}, ...&gt; %Operate.Cell{op: &quot;return function(state, a) return (state or 0) + a end&quot;, params: [4]} ...&gt; ]} ...&gt; |&gt; Operate.Tape.run(Operate.VM.init) ...&gt; tape.result 9"},{"ref":"Operate.Tape.html#from_bpu/2","title":"Operate.Tape.from_bpu/2","type":"function","doc":"Converts the given Operate.BPU.Transaction.t/0 into a Operate.Tape.t/0. Returns the result in an :ok / :error tuple pair. Optionally specifcy the output index of the tape. If not specified, the first OP_RETURN output is returned as the tape."},{"ref":"Operate.Tape.html#from_bpu!/2","title":"Operate.Tape.from_bpu!/2","type":"function","doc":"As from_bpu/1, but returns the result or raises an exception."},{"ref":"Operate.Tape.html#get_op_refs/2","title":"Operate.Tape.get_op_refs/2","type":"function","doc":"Returns a list of Op references from the tape&#39;s cells. If a map of aliases is specifed, this is used to alias references to alternative values. Examples iex&gt; %Operate.Tape{cells: [ ...&gt; %Operate.Cell{ref: &quot;aabbccdd&quot;}, ...&gt; %Operate.Cell{ref: &quot;eeff1122&quot;}, ...&gt; %Operate.Cell{ref: &quot;33445500&quot;} ...&gt; ]} ...&gt; |&gt; Operate.Tape.get_op_refs(%{&quot;33445500&quot; =&gt; &quot;MyAliasReference&quot;}) [&quot;aabbccdd&quot;, &quot;eeff1122&quot;, &quot;MyAliasReference&quot;]"},{"ref":"Operate.Tape.html#run/3","title":"Operate.Tape.run/3","type":"function","doc":"Runs the tape in the given VM state. Options The accepted options are: :state - Specifiy the state passed to the first cell procedure. Defaults to nil. :strict - By default the tape runs in struct mode - meaning if any cell has an error the entire tape fails. Disable strict mode by setting to false. Examples iex&gt; {:ok, tape} = %Operate.Tape{cells: [ ...&gt; %Operate.Cell{op: &quot;return function(state, a) return (state or &#39;&#39;) .. a end&quot;, params: [&quot;b&quot;]}, ...&gt; %Operate.Cell{op: &quot;return function(state, a) return (state or &#39;&#39;) .. a end&quot;, params: [&quot;c&quot;]}, ...&gt; %Operate.Cell{op: &quot;return function(state) return string.reverse(state) end&quot;, params: []} ...&gt; ]} ...&gt; |&gt; Operate.Tape.run(Operate.VM.init, state: &quot;a&quot;) ...&gt; tape.result &quot;cba&quot;"},{"ref":"Operate.Tape.html#run!/3","title":"Operate.Tape.run!/3","type":"function","doc":"As run/3, but returns the tape or raises an exception. Options The accepted options are: :state - Specifiy the state passed to the first cell procedure. Defaults to nil. :strict - By default the tape runs in struct mode - meaning if any cell has an error the entire tape fails. Disable strict mode by setting to false."},{"ref":"Operate.Tape.html#set_cell_ops/3","title":"Operate.Tape.set_cell_ops/3","type":"function","doc":"Sets the given Ops into the cells of the given tape. If a map of aliases is specifed, this is used to reverse map any procedure scripts onto aliased cells."},{"ref":"Operate.Tape.html#valid?/1","title":"Operate.Tape.valid?/1","type":"function","doc":"Validates the given tape. Returns true if all the tape&#39;s cells are valid."},{"ref":"Operate.Tape.html#t:t/0","title":"Operate.Tape.t/0","type":"type","doc":"Operate Tape"},{"ref":"Operate.Util.html","title":"Operate.Util","type":"module","doc":"A collection of commonly used helper functions."},{"ref":"Operate.Util.html#restruct/1","title":"Operate.Util.restruct/1","type":"function","doc":"Converts the given map into a struct. Must be used with a struct that has previously been serialised into a map with stringified keys and still contains the &quot;__struct__&quot; key. Examples iex&gt; test = Operate.Util.restruct(%{&quot;__struct__&quot; =&gt; &quot;Elixir.Operate.Cell&quot;}) ...&gt; test.__struct__ == Operate.Cell true"},{"ref":"Operate.VM.html","title":"Operate.VM","type":"module","doc":"Operate VM module. Responsible for initalizing the VM state and evaluating and executing Lua code in the VM."},{"ref":"Operate.VM.html#call/3","title":"Operate.VM.call/3","type":"function","doc":"Calls a function within the VM state at the given lua path and returns the result. Examples iex&gt; Operate.VM.init ...&gt; |&gt; Operate.VM.exec!(&quot;function main() return &#39;hello world&#39; end&quot;) ...&gt; |&gt; Operate.VM.call(:main) {:ok, &quot;hello world&quot;} iex&gt; Operate.VM.init ...&gt; |&gt; Operate.VM.exec!(&quot;function sum(a, b) return a + b end&quot;) ...&gt; |&gt; Operate.VM.call(:sum, [2, 3]) {:ok, 5}"},{"ref":"Operate.VM.html#call!/3","title":"Operate.VM.call!/3","type":"function","doc":"As call/3, but returns the result or raises an exception. Examples iex&gt; Operate.VM.init ...&gt; |&gt; Operate.VM.exec!(&quot;function main() return &#39;hello world&#39; end&quot;) ...&gt; |&gt; Operate.VM.call!(:main) &quot;hello world&quot;"},{"ref":"Operate.VM.html#decode/1","title":"Operate.VM.decode/1","type":"function","doc":"Decodes a value returned from the VM state into an Elixir type. Automatically detects when 64 bit long numbers can be converted to integers, and handles converting Lua tables into either Elixir lists or maps. Examples iex&gt; Operate.VM.decode(23.23) 23.23 iex&gt; Operate.VM.decode(23.0) 23 iex&gt; Operate.VM.decode([{&quot;foo&quot;, 1}, {&quot;bar&quot;, 2}]) %{&quot;foo&quot; =&gt; 1, &quot;bar&quot; =&gt; 2}"},{"ref":"Operate.VM.html#eval/2","title":"Operate.VM.eval/2","type":"function","doc":"Evaluates the given script within the VM state and returns the result. Examples iex&gt; Operate.VM.init ...&gt; |&gt; Operate.VM.eval(&quot;return &#39;hello world&#39;&quot;) {:ok, &quot;hello world&quot;} iex&gt; Operate.VM.init ...&gt; |&gt; Operate.VM.eval(&quot;return 2 / 3&quot;) {:ok, 0.6666666666666666}"},{"ref":"Operate.VM.html#eval!/2","title":"Operate.VM.eval!/2","type":"function","doc":"As eval/2, but returns the result or raises an exception. Examples iex&gt; Operate.VM.init ...&gt; |&gt; Operate.VM.eval!(&quot;return &#39;hello world&#39;&quot;) &quot;hello world&quot;"},{"ref":"Operate.VM.html#exec/2","title":"Operate.VM.exec/2","type":"function","doc":"Evaluates the given script within the VM state and returns the modified state."},{"ref":"Operate.VM.html#exec!/2","title":"Operate.VM.exec!/2","type":"function","doc":"As exec/2, but returns the modified state or raises an exception."},{"ref":"Operate.VM.html#exec_function/2","title":"Operate.VM.exec_function/2","type":"function","doc":"Executes the given function with the given arguments. Examples iex&gt; Operate.VM.init ...&gt; |&gt; Operate.VM.eval!(&quot;return function(a,b) return a * b end&quot;) ...&gt; |&gt; Operate.VM.exec_function([3,4]) {:ok, 12}"},{"ref":"Operate.VM.html#exec_function!/2","title":"Operate.VM.exec_function!/2","type":"function","doc":"As exec_function/2, but returns the result or raises an exception. Examples iex&gt; Operate.VM.init ...&gt; |&gt; Operate.VM.eval!(&quot;return function(a,b) return a .. &#39; &#39; .. b end&quot;) ...&gt; |&gt; Operate.VM.exec_function!([&quot;hello&quot;, &quot;world&quot;]) &quot;hello world&quot;"},{"ref":"Operate.VM.html#extend/2","title":"Operate.VM.extend/2","type":"function","doc":"Extends the VM state with the given module or modules. Examples Operate.VM.extend(vm, [MyLuaExtension, OtherExtension])"},{"ref":"Operate.VM.html#get/2","title":"Operate.VM.get/2","type":"function","doc":"Returns the value from the specified path on the VM state. Examples iex&gt; Operate.VM.init ...&gt; |&gt; Operate.VM.set!(&quot;foo.bar&quot;, 42, force: true) ...&gt; |&gt; Operate.VM.get(&quot;foo&quot;) {:ok, %{&quot;bar&quot; =&gt; 42}} iex&gt; Operate.VM.init ...&gt; |&gt; Operate.VM.set!(&quot;foo.bar&quot;, 42, force: true) ...&gt; |&gt; Operate.VM.get(&quot;foo.bar&quot;) {:ok, 42}"},{"ref":"Operate.VM.html#get!/2","title":"Operate.VM.get!/2","type":"function","doc":"As get/2, but returns the result or raises an exception. Examples iex&gt; Operate.VM.init ...&gt; |&gt; Operate.VM.set!(&quot;foo.bar&quot;, 42, force: true) ...&gt; |&gt; Operate.VM.get!(&quot;foo.bar&quot;) 42"},{"ref":"Operate.VM.html#init/1","title":"Operate.VM.init/1","type":"function","doc":"Initliazes a new VM state. Options The accepted options are: :extensions - Provide a list of modules with which to extend the VM state. Examples iex&gt; vm = Operate.VM.init ...&gt; elem(vm, 0) == :luerl true"},{"ref":"Operate.VM.html#parse_opts/1","title":"Operate.VM.parse_opts/1","type":"function","doc":"Parses the given map decoded from the VM, and recursively transforms it into a keyword list with atom keys. Examples iex&gt; Operate.VM.parse_opts(%{&quot;foo&quot; =&gt; 1, &quot;bar&quot; =&gt; %{&quot;baz&quot; =&gt; 2}}) [bar: [baz: 2], foo: 1] iex&gt; [{&quot;foo&quot;, 1}, {&quot;bar&quot;, 2}] ...&gt; |&gt; Operate.VM.decode ...&gt; |&gt; Operate.VM.parse_opts [bar: 2, foo: 1]"},{"ref":"Operate.VM.html#set/4","title":"Operate.VM.set/4","type":"function","doc":"Sets the value at the specified path on the given VM state and returns a modified VM state. Options The accepted options are: :force - Recusively set the value at a deep path that doesn&#39;t already exist. Examples iex&gt; {:ok, vm} = Operate.VM.init ...&gt; |&gt; Operate.VM.set(&quot;foo.bar&quot;, 42, force: true) ...&gt; elem(vm, 0) :luerl"},{"ref":"Operate.VM.html#set!/4","title":"Operate.VM.set!/4","type":"function","doc":"As set/4, but returns the VM state or raises an exception. Options The accepted options are: :force - Recusively set the value at a deep path that doesn&#39;t already exist. Examples iex&gt; vm = Operate.VM.init ...&gt; |&gt; Operate.VM.set!(&quot;foo.bar&quot;, 42, force: true) ...&gt; elem(vm, 0) :luerl"},{"ref":"Operate.VM.html#set_function/4","title":"Operate.VM.set_function/4","type":"function","doc":"Sets an Elixir function at the specified path on the given VM state and returns the modified VM state. Options The accepted options are: :force - Recusively set the value at a deep path that doesn&#39;t already exist."},{"ref":"Operate.VM.html#set_function!/4","title":"Operate.VM.set_function!/4","type":"function","doc":"As set_function/4, but returns the VM state or raises an exception. Options The accepted options are: :force - Recusively set the value at a deep path that doesn&#39;t already exist."},{"ref":"Operate.VM.html#t:lua_output/0","title":"Operate.VM.lua_output/0","type":"type","doc":"Operate return value"},{"ref":"Operate.VM.html#t:lua_path/0","title":"Operate.VM.lua_path/0","type":"type","doc":"Lua table path. Either a dot-delimited string or list of strings or atoms."},{"ref":"Operate.VM.html#t:t/0","title":"Operate.VM.t/0","type":"type","doc":"Operate VM state"},{"ref":"Operate.VM.Extension.html","title":"Operate.VM.Extension","type":"behaviour","doc":"Operate VM extension specification. The Operate Lua VM can be easily extended, either with native Lua modules, or Elixir code that is added to the Lua VM as functions. Examples defmodule MyExtension do use Operate.VM.Extension alias Operate.VMr def extend(vm) do vm |&gt; VM.set!(&quot;msg&quot;, &quot;hello world&quot;) |&gt; VM.exec!(&quot;function hello() return msg end&quot;) |&gt; VM.set_function!(&quot;sum&quot;, fn _vm, args -&gt; apply(__MODULE__, :sum, args) end) end def sum(a,b) do a + b end end"},{"ref":"Operate.VM.Extension.html#c:extend/1","title":"Operate.VM.Extension.extend/1","type":"callback","doc":"Extends the given VM state, returning the modified state."},{"ref":"Operate.VM.Extension.Agent.html","title":"Operate.VM.Extension.Agent","type":"module","doc":"Extends the VM state with functions for accessing the running agent."},{"ref":"Operate.VM.Extension.Agent.html#exec/2","title":"Operate.VM.Extension.Agent.exec/2","type":"function","doc":"Loads and runs a tape from the given txid"},{"ref":"Operate.VM.Extension.Agent.html#extend/1","title":"Operate.VM.Extension.Agent.extend/1","type":"function","doc":"Extends the given VM state, returning the modified state. Callback implementation for Operate.VM.Extension.extend/1."},{"ref":"Operate.VM.Extension.Agent.html#load_tape/2","title":"Operate.VM.Extension.Agent.load_tape/2","type":"function","doc":"Loads a tape by the given txid and returns the tape"},{"ref":"Operate.VM.Extension.Agent.html#load_tapes_by/2","title":"Operate.VM.Extension.Agent.load_tapes_by/2","type":"function","doc":"Loads a list of tapes by the given query and returns the list"},{"ref":"Operate.VM.Extension.Agent.html#local_tape/3","title":"Operate.VM.Extension.Agent.local_tape/3","type":"function","doc":"Loads a tape by the given txid and returns the tape"},{"ref":"Operate.VM.Extension.Agent.html#run_tape/2","title":"Operate.VM.Extension.Agent.run_tape/2","type":"function","doc":"Runs the given tape, and returns the result"},{"ref":"Operate.VM.Extension.Base.html","title":"Operate.VM.Extension.Base","type":"module","doc":"Extends the VM state with functions for encoding and decoding hex and base64 strings."},{"ref":"Operate.VM.Extension.Base.html#decode16/1","title":"Operate.VM.Extension.Base.decode16/1","type":"function","doc":"Decodes the given hex string into a binary string."},{"ref":"Operate.VM.Extension.Base.html#decode64/1","title":"Operate.VM.Extension.Base.decode64/1","type":"function","doc":"Decodes the given hex string into a binary string."},{"ref":"Operate.VM.Extension.Base.html#encode16/1","title":"Operate.VM.Extension.Base.encode16/1","type":"function","doc":"Encodes the given binary string into a hex string."},{"ref":"Operate.VM.Extension.Base.html#encode64/1","title":"Operate.VM.Extension.Base.encode64/1","type":"function","doc":"Encodes the given binary string into a hex string."},{"ref":"Operate.VM.Extension.Base.html#extend/1","title":"Operate.VM.Extension.Base.extend/1","type":"function","doc":"Extends the given VM state, returning the modified state. Callback implementation for Operate.VM.Extension.extend/1."},{"ref":"Operate.VM.Extension.Context.html","title":"Operate.VM.Extension.Context","type":"module","doc":"Extends the VM state with functions for accessing the transaction context."},{"ref":"Operate.VM.Extension.Context.html#extend/1","title":"Operate.VM.Extension.Context.extend/1","type":"function","doc":"Extends the given VM state, returning the modified state. Callback implementation for Operate.VM.Extension.extend/1."},{"ref":"Operate.VM.Extension.Context.html#get_cell/1","title":"Operate.VM.Extension.Context.get_cell/1","type":"function","doc":""},{"ref":"Operate.VM.Extension.Context.html#get_cell/2","title":"Operate.VM.Extension.Context.get_cell/2","type":"function","doc":"Fetches the current tape from the context tx."},{"ref":"Operate.VM.Extension.Context.html#get_tape/1","title":"Operate.VM.Extension.Context.get_tape/1","type":"function","doc":"Fetches the current tape from the context tx."},{"ref":"Operate.VM.Extension.Context.html#tx_input/2","title":"Operate.VM.Extension.Context.tx_input/2","type":"function","doc":"Fetches the input from the context tx."},{"ref":"Operate.VM.Extension.Context.html#tx_output/2","title":"Operate.VM.Extension.Context.tx_output/2","type":"function","doc":"Fetches the output from the context tx."},{"ref":"Operate.VM.Extension.Crypto.html","title":"Operate.VM.Extension.Crypto","type":"module","doc":"Extends the VM state with common crypto functions."},{"ref":"Operate.VM.Extension.Crypto.html#aes_decrypt/3","title":"Operate.VM.Extension.Crypto.aes_decrypt/3","type":"function","doc":"Decrypts the given data with the given secret using AES-GCM."},{"ref":"Operate.VM.Extension.Crypto.html#aes_encrypt/3","title":"Operate.VM.Extension.Crypto.aes_encrypt/3","type":"function","doc":"Encrypts the given data with the given secret using AES-GCM."},{"ref":"Operate.VM.Extension.Crypto.html#bitcoin_message_sign/3","title":"Operate.VM.Extension.Crypto.bitcoin_message_sign/3","type":"function","doc":"Signs the given Bitcoin Message with the given ECDSA private key."},{"ref":"Operate.VM.Extension.Crypto.html#bitcoin_message_verify/4","title":"Operate.VM.Extension.Crypto.bitcoin_message_verify/4","type":"function","doc":"Verifies the given signature and Bitcoin Message with the given ECDSA public key."},{"ref":"Operate.VM.Extension.Crypto.html#ecdsa_sign/3","title":"Operate.VM.Extension.Crypto.ecdsa_sign/3","type":"function","doc":"Signs the given data with the given ECDSA private key."},{"ref":"Operate.VM.Extension.Crypto.html#ecdsa_verify/4","title":"Operate.VM.Extension.Crypto.ecdsa_verify/4","type":"function","doc":"Verifies the given signature and message with the given ECDSA public key."},{"ref":"Operate.VM.Extension.Crypto.html#ecies_decrypt/3","title":"Operate.VM.Extension.Crypto.ecies_decrypt/3","type":"function","doc":"Decrypts the given data with the given ECDSA private key using ECIES."},{"ref":"Operate.VM.Extension.Crypto.html#ecies_encrypt/3","title":"Operate.VM.Extension.Crypto.ecies_encrypt/3","type":"function","doc":"Encrypts the given data with the given ECDSA public key using ECIES."},{"ref":"Operate.VM.Extension.Crypto.html#extend/1","title":"Operate.VM.Extension.Crypto.extend/1","type":"function","doc":"Extends the given VM state, returning the modified state. Callback implementation for Operate.VM.Extension.extend/1."},{"ref":"Operate.VM.Extension.Crypto.html#hash/3","title":"Operate.VM.Extension.Crypto.hash/3","type":"function","doc":"Hashes the given data using the specified algorithm."},{"ref":"Operate.VM.Extension.Crypto.html#rsa_decrypt/3","title":"Operate.VM.Extension.Crypto.rsa_decrypt/3","type":"function","doc":"Decrypts the given data with the given RSA public or private key."},{"ref":"Operate.VM.Extension.Crypto.html#rsa_encrypt/3","title":"Operate.VM.Extension.Crypto.rsa_encrypt/3","type":"function","doc":"Encrypts the given data with the given RSA public or private key."},{"ref":"Operate.VM.Extension.Crypto.html#rsa_sign/3","title":"Operate.VM.Extension.Crypto.rsa_sign/3","type":"function","doc":"Signs the given data with the given RSA private key."},{"ref":"Operate.VM.Extension.Crypto.html#rsa_verify/4","title":"Operate.VM.Extension.Crypto.rsa_verify/4","type":"function","doc":"Verifies the given signature and message with the given RSA public key."},{"ref":"Operate.VM.Extension.JSON.html","title":"Operate.VM.Extension.JSON","type":"module","doc":"Extends the VM state with functions for encoding and decoding JSON."},{"ref":"Operate.VM.Extension.JSON.html#decode/1","title":"Operate.VM.Extension.JSON.decode/1","type":"function","doc":"Decodes the given JSON string."},{"ref":"Operate.VM.Extension.JSON.html#encode/1","title":"Operate.VM.Extension.JSON.encode/1","type":"function","doc":"Encodes the given value into a JSON string,"},{"ref":"Operate.VM.Extension.JSON.html#extend/1","title":"Operate.VM.Extension.JSON.extend/1","type":"function","doc":"Extends the given VM state, returning the modified state. Callback implementation for Operate.VM.Extension.extend/1."},{"ref":"Operate.VM.Extension.String.html","title":"Operate.VM.Extension.String","type":"module","doc":"Extends the VM state with implementations of Lua&#39;s string.pack and string.unpack functions."},{"ref":"Operate.VM.Extension.String.html#extend/1","title":"Operate.VM.Extension.String.extend/1","type":"function","doc":"Extends the given VM state, returning the modified state. Callback implementation for Operate.VM.Extension.extend/1."},{"ref":"Operate.VM.Extension.String.html#pack/2","title":"Operate.VM.Extension.String.pack/2","type":"function","doc":"Packs the given values into a binary using the specified format."},{"ref":"Operate.VM.Extension.String.html#parse_format/1","title":"Operate.VM.Extension.String.parse_format/1","type":"function","doc":""},{"ref":"Operate.VM.Extension.String.html#unpack/3","title":"Operate.VM.Extension.String.unpack/3","type":"function","doc":"Unpacks the given binary string into a list of values using the specified format. Returns a list, the final element being the index of the next unread byte."},{"ref":"Operate.Adapter.html","title":"Operate.Adapter","type":"behaviour","doc":"Operate adapter specification. An adapter is responsible for loading tapes and ops from a datasource - potentially a web API, a database or even a Bitcoin node. Operate ships with two default adapters, although these can be swapped out with any other adpater by changing the configuration: children = [ {Operate, [ tape_adapter: Operate.Adapter.Bob, op_adapter: Operate.Adapter.OpApi ]} ] Supervisor.start_link(children, strategy: :one_for_one) Creating an adapter An adapter must implement one or more of the following callbacks: fetch_tx/2 - function that takes a txid and returns a Operate.BPU.Transaction.t/0. fetch_tx_by/2 - function that takes a map and returns a list of Operate.BPU.Transaction.t/0 tx. fetch_ops/2 - function that takes a list of Op references and returns a list of Operate.Op.t/0 functions. Example: defmodule MyAdapter do use Operate.Adapter def fetch_tx(txid, opts) do key = Keyword.get(opts, :api_key) BitcoinApi.load_tx(txid, api_key: key) |&gt; to_bpu end defp to_bpu(tx) do # Map tx object to `Operate.BPU.Transaction.t` end end Using the above example, Operate can be configured with: {Operate, [ tape_adapter: {MyAdapter, [api_key: &quot;myapikey&quot;]} ]}"},{"ref":"Operate.Adapter.html#c:fetch_ops/2","title":"Operate.Adapter.fetch_ops/2","type":"callback","doc":"Fetches a list of Ops by the given list of Op references. Returns the result in an :ok / :error tuple pair."},{"ref":"Operate.Adapter.html#c:fetch_ops!/2","title":"Operate.Adapter.fetch_ops!/2","type":"callback","doc":"As fetch_ops/2, but returns the result or raises an exception."},{"ref":"Operate.Adapter.html#c:fetch_tx/2","title":"Operate.Adapter.fetch_tx/2","type":"callback","doc":"Fetches a transaction by the given txid, and returns the result in an :ok / :error tuple pair."},{"ref":"Operate.Adapter.html#c:fetch_tx!/2","title":"Operate.Adapter.fetch_tx!/2","type":"callback","doc":"As fetch_tx/2, but returns the transaction or raises an exception."},{"ref":"Operate.Adapter.html#c:fetch_tx_by/2","title":"Operate.Adapter.fetch_tx_by/2","type":"callback","doc":"Fetches a list of transactions by the given query map, and returns the result in an :ok / :error tuple pair."},{"ref":"Operate.Adapter.html#c:fetch_tx_by!/2","title":"Operate.Adapter.fetch_tx_by!/2","type":"callback","doc":"As fetch_tx_by/2, but returns the result or raises an exception."},{"ref":"Operate.Adapter.Bob.html","title":"Operate.Adapter.Bob","type":"module","doc":"Adapter module for loading tapes and Ops from BOB. Examples iex&gt; Operate.Adapter.Bob.fetch_tx(txid, api_key: &quot;mykey&quot;) {:ok, %Operate.BPU.Transaction{}}"},{"ref":"Operate.Adapter.Bob.html#fetch_ops/2","title":"Operate.Adapter.Bob.fetch_ops/2","type":"function","doc":"Fetches a list of Ops by the given list of Op references. Returns the result in an :ok / :error tuple pair. Callback implementation for Operate.Adapter.fetch_ops/2."},{"ref":"Operate.Adapter.Bob.html#fetch_ops!/2","title":"Operate.Adapter.Bob.fetch_ops!/2","type":"function","doc":"As c:fetch_ops/2, but returns the result or raises an exception. Callback implementation for Operate.Adapter.fetch_ops!/2."},{"ref":"Operate.Adapter.Bob.html#fetch_tx/2","title":"Operate.Adapter.Bob.fetch_tx/2","type":"function","doc":"Fetches a transaction by the given txid, and returns the result in an :ok / :error tuple pair. Callback implementation for Operate.Adapter.fetch_tx/2."},{"ref":"Operate.Adapter.Bob.html#fetch_tx!/2","title":"Operate.Adapter.Bob.fetch_tx!/2","type":"function","doc":"As c:fetch_tx/2, but returns the transaction or raises an exception. Callback implementation for Operate.Adapter.fetch_tx!/2."},{"ref":"Operate.Adapter.Bob.html#fetch_tx_by/2","title":"Operate.Adapter.Bob.fetch_tx_by/2","type":"function","doc":"Fetches a list of transactions by the given query map, and returns the result in an :ok / :error tuple pair. The query parameter should be a valid Bitquery. The project attribute cannot be used and unless otherwise specified, limit defaults to 10. Options The accepted options are: :api_key - Planaria API key Examples Operate.Adapter.Bob.fetch_tx_by(%{ &quot;find&quot; =&gt; %{ &quot;out.tape.cell&quot; =&gt; %{ &quot;$elemMatch&quot; =&gt; %{ &quot;i&quot; =&gt; 0, &quot;s&quot; =&gt; &quot;1PuQa7K62MiKCtssSLKy1kh56WWU7MtUR5&quot; } } } })"},{"ref":"Operate.Adapter.Bob.html#fetch_tx_by!/2","title":"Operate.Adapter.Bob.fetch_tx_by!/2","type":"function","doc":"As c:fetch_tx_by/2, but returns the result or raises an exception. Callback implementation for Operate.Adapter.fetch_tx_by!/2."},{"ref":"Operate.Adapter.Bob.html#to_bpu/1","title":"Operate.Adapter.Bob.to_bpu/1","type":"function","doc":"Converts the map from the Planaria HTTP response to a Operate.BPU.Transaction.t/0."},{"ref":"Operate.Adapter.Bob.html#t:option/0","title":"Operate.Adapter.Bob.option/0","type":"type","doc":""},{"ref":"Operate.Adapter.OpApi.html","title":"Operate.Adapter.OpApi","type":"module","doc":"Adapter module for loading Ops from the Operate API. Examples iex&gt; Operate.Adapter.Hub.fetch_ops(refs) {:ok, [%Operate.Op{}, ...]}"},{"ref":"Operate.Adapter.OpApi.html#fetch_ops/2","title":"Operate.Adapter.OpApi.fetch_ops/2","type":"function","doc":"Fetches a list of Ops by the given list of Op references. Returns the result in an :ok / :error tuple pair. Callback implementation for Operate.Adapter.fetch_ops/2."},{"ref":"Operate.Adapter.OpApi.html#fetch_ops!/2","title":"Operate.Adapter.OpApi.fetch_ops!/2","type":"function","doc":"As c:fetch_ops/2, but returns the result or raises an exception. Callback implementation for Operate.Adapter.fetch_ops!/2."},{"ref":"Operate.Adapter.OpApi.html#fetch_tx/2","title":"Operate.Adapter.OpApi.fetch_tx/2","type":"function","doc":"Fetches a transaction by the given txid, and returns the result in an :ok / :error tuple pair. Callback implementation for Operate.Adapter.fetch_tx/2."},{"ref":"Operate.Adapter.OpApi.html#fetch_tx!/2","title":"Operate.Adapter.OpApi.fetch_tx!/2","type":"function","doc":"As c:fetch_tx/2, but returns the transaction or raises an exception. Callback implementation for Operate.Adapter.fetch_tx!/2."},{"ref":"Operate.Adapter.OpApi.html#fetch_tx_by/2","title":"Operate.Adapter.OpApi.fetch_tx_by/2","type":"function","doc":"Fetches a list of transactions by the given query map, and returns the result in an :ok / :error tuple pair. Callback implementation for Operate.Adapter.fetch_tx_by/2."},{"ref":"Operate.Adapter.OpApi.html#fetch_tx_by!/2","title":"Operate.Adapter.OpApi.fetch_tx_by!/2","type":"function","doc":"As c:fetch_tx_by/2, but returns the result or raises an exception. Callback implementation for Operate.Adapter.fetch_tx_by!/2."},{"ref":"Operate.Adapter.OpApi.html#t:option/0","title":"Operate.Adapter.OpApi.option/0","type":"type","doc":""},{"ref":"Operate.Cache.html","title":"Operate.Cache","type":"behaviour","doc":"Operate cache specification. A cache is responsible for storing and retrieving tapes and ops from a cache, and if necessary instructing an adapter to fetch items from a data source. Operate comes bundled with a ConCache ETS cache, although by default runs without any caching. Creating a cache A cache must implement both of the following callbacks: fetch_tx/3 - function that takes a txid and returns a Operate.BPU.Transaction.t/0 fetch_ops/3 - function that takes a list of Op references and returns a list of Operate.Op.t/0 functions. The third argument in both functions is a tuple containing the adapter module and a keyword list of options to pass to the adapter. defmodule MyCache do use Operate.Cache def fetch_tx(txid, opts, {adapter, adapter_opts}) do ttl = Keyword.get(opts, :ttl, 3600) Cache.fetch_or_store(txid, ttl: ttl, fn -&gt; adapter.fetch_tx(txid, adapter_opts) end) end end Using the above example, Operate can be configured with: {Operate, [ cache: {MyCache, [ttl: 3600]} ]}"},{"ref":"Operate.Cache.html#c:fetch_ops/3","title":"Operate.Cache.fetch_ops/3","type":"callback","doc":"Loads Ops from the cache by the given procedure referneces, or delegates the job to the specified adapter. Returns the result in an :ok / :error tuple pair."},{"ref":"Operate.Cache.html#c:fetch_ops!/3","title":"Operate.Cache.fetch_ops!/3","type":"callback","doc":"As fetch_ops/3, but returns the result or raises an exception."},{"ref":"Operate.Cache.html#c:fetch_tx/3","title":"Operate.Cache.fetch_tx/3","type":"callback","doc":"Loads a transaction from the cache by the given txid, or delegates to job to the specified adapter. Returns the result in an :ok / :error tuple pair."},{"ref":"Operate.Cache.html#c:fetch_tx!/3","title":"Operate.Cache.fetch_tx!/3","type":"callback","doc":"As fetch_tx/3, but returns the transaction or raises an exception."},{"ref":"Operate.Cache.html#c:fetch_tx_by/3","title":"Operate.Cache.fetch_tx_by/3","type":"callback","doc":"Loads a list of transactions from the cache by the given query map, or delegates to job to the specified adapter. Returns the result in an :ok / :error tuple pair."},{"ref":"Operate.Cache.html#c:fetch_tx_by!/3","title":"Operate.Cache.fetch_tx_by!/3","type":"callback","doc":"As fetch_tx_by/3, but returns the result or raises an exception."},{"ref":"Operate.Cache.ConCache.html","title":"Operate.Cache.ConCache","type":"module","doc":"Cache module implementing an ETS based cache, using ConCache. To enable this cache, ConCache needs to be started from a supervisor: children = [ {Operate, [ cache: Operate.Cache.ConCache, ]}, {ConCache, [ name: :operate, ttl_check_interval: :timer.minutes(1), global_ttl: :timer.minutes(10), touch_on_read: true ]} ] Supervisor.start_link(children, strategy: :one_for_one)"},{"ref":"Operate.Cache.ConCache.html#fetch_ops/3","title":"Operate.Cache.ConCache.fetch_ops/3","type":"function","doc":"Loads Ops from the cache by the given procedure referneces, or delegates the job to the specified adapter. Returns the result in an :ok / :error tuple pair. Callback implementation for Operate.Cache.fetch_ops/3."},{"ref":"Operate.Cache.ConCache.html#fetch_ops!/3","title":"Operate.Cache.ConCache.fetch_ops!/3","type":"function","doc":"As c:fetch_ops/3, but returns the result or raises an exception. Callback implementation for Operate.Cache.fetch_ops!/3."},{"ref":"Operate.Cache.ConCache.html#fetch_tx/3","title":"Operate.Cache.ConCache.fetch_tx/3","type":"function","doc":"Loads a transaction from the cache by the given txid, or delegates to job to the specified adapter. Returns the result in an :ok / :error tuple pair. Callback implementation for Operate.Cache.fetch_tx/3."},{"ref":"Operate.Cache.ConCache.html#fetch_tx!/3","title":"Operate.Cache.ConCache.fetch_tx!/3","type":"function","doc":"As c:fetch_tx/3, but returns the transaction or raises an exception. Callback implementation for Operate.Cache.fetch_tx!/3."},{"ref":"Operate.Cache.ConCache.html#fetch_tx_by/3","title":"Operate.Cache.ConCache.fetch_tx_by/3","type":"function","doc":"Loads a list of transactions from the cache by the given query map, or delegates to job to the specified adapter. Returns the result in an :ok / :error tuple pair. Callback implementation for Operate.Cache.fetch_tx_by/3."},{"ref":"Operate.Cache.ConCache.html#fetch_tx_by!/3","title":"Operate.Cache.ConCache.fetch_tx_by!/3","type":"function","doc":"As c:fetch_tx_by/3, but returns the result or raises an exception. Callback implementation for Operate.Cache.fetch_tx_by!/3."},{"ref":"Operate.Cache.NoCache.html","title":"Operate.Cache.NoCache","type":"module","doc":"Cache module for implementing no caching. This is the default cache module, and allows Operate to run without any caching, simply by forwarding and requests for tapes or ops to the configured adpater module(s) skipping any cache layers."},{"ref":"Operate.Cache.NoCache.html#fetch_ops/3","title":"Operate.Cache.NoCache.fetch_ops/3","type":"function","doc":"Loads Ops from the cache by the given procedure referneces, or delegates the job to the specified adapter. Returns the result in an :ok / :error tuple pair. Callback implementation for Operate.Cache.fetch_ops/3."},{"ref":"Operate.Cache.NoCache.html#fetch_ops!/3","title":"Operate.Cache.NoCache.fetch_ops!/3","type":"function","doc":"As c:fetch_ops/3, but returns the result or raises an exception. Callback implementation for Operate.Cache.fetch_ops!/3."},{"ref":"Operate.Cache.NoCache.html#fetch_tx/3","title":"Operate.Cache.NoCache.fetch_tx/3","type":"function","doc":"Loads a transaction from the cache by the given txid, or delegates to job to the specified adapter. Returns the result in an :ok / :error tuple pair. Callback implementation for Operate.Cache.fetch_tx/3."},{"ref":"Operate.Cache.NoCache.html#fetch_tx!/3","title":"Operate.Cache.NoCache.fetch_tx!/3","type":"function","doc":"As c:fetch_tx/3, but returns the transaction or raises an exception. Callback implementation for Operate.Cache.fetch_tx!/3."},{"ref":"Operate.Cache.NoCache.html#fetch_tx_by/3","title":"Operate.Cache.NoCache.fetch_tx_by/3","type":"function","doc":"Loads a list of transactions from the cache by the given query map, or delegates to job to the specified adapter. Returns the result in an :ok / :error tuple pair. Callback implementation for Operate.Cache.fetch_tx_by/3."},{"ref":"Operate.Cache.NoCache.html#fetch_tx_by!/3","title":"Operate.Cache.NoCache.fetch_tx_by!/3","type":"function","doc":"As c:fetch_tx_by/3, but returns the result or raises an exception. Callback implementation for Operate.Cache.fetch_tx_by!/3."}]